#include <MidiConsumer.h>
#include <USBKit.h>

class UC16Out : public BMidiLocalConsumer {
public:
	UC16Out(const USBEndpoint *point, const char* name);
	
	virtual	void NoteOn(uchar channel, uchar note, uchar velocity, bigtime_t time);
	virtual	void NoteOff(uchar channel, uchar note, uchar velocity, bigtime_t time);
	virtual	void KeyPressure(uchar channel, uchar note, uchar pressure, bigtime_t time);
	virtual	void ControlChange(uchar channel, uchar controlNumber, uchar controlValue, bigtime_t time);
	virtual	void ProgramChange(uchar channel, uchar programNumber, bigtime_t time);
	virtual	void ChannelPressure(uchar channel, uchar pressure, bigtime_t time);
	virtual	void PitchBend(uchar channel, uchar lsb, uchar msb, bigtime_t time);
	virtual	void SystemExclusive(void* i_data, size_t dataLength, bigtime_t time);
	virtual	void SystemCommon(uchar statusByte, uchar data1, uchar data2, bigtime_t time);
	virtual	void SystemRealTime(uchar statusByte, bigtime_t time);
	virtual	void TempoChange(int32 bpm, bigtime_t time);
	virtual void AllNotesOff(bool justChannel, bigtime_t time);
	
	const USBDevice *GetDevice(void){
		return uc16;
	}
	
private:
	const USBDevice *uc16;
	const USBEndpoint *ept;
	uchar data[4];
};